from setop import *
from input_time import *
import numpy as np
import functools as ft



s=number_st


def schur(A,B):
    return A*B

def pref_mat(pref):
    X=np.zeros([len(pref),len(pref)])
    lis=list(pref)
    for i in range(len(lis)):
        for j in range(len(lis)):
            p=len(lis)-1-int(lis.index(i+1))
            q=len(lis)-1-int(lis.index(j+1))
            I=lis[p]
            J=lis[q]
            if p>q:
                X[I-1][J-1]=1
            elif p==q:
                X[I-1][J-1]=0
            elif p<q:
                X[I-1][J-1]=0
    return X



def NO(A):
    for i in range(0, len(A)):
        for j in range(0,len(A)):
            if A[i][j]==0:
                A[i][j]=0
            elif A[i][j]!=0:
                A[i][j]=1
    return A


def T(A):
    return np.transpose(A)



def NE(A):
    if np.size(A,1)==1:
        for i in range(np.size(A,0)):
            if A[i]==0:
                A[i]=1
            elif A[i]!=0:
                A[i]=0
        return A
    elif np.size(A,0)==1:
        for i in range(np.size(A,1)):
            if A[0][i]==0:
                A[0][i]=1
            elif A[0][i]!=0:
                A[0][i]=0
        return A
    else:
        for i in range(len(A)):
            for j in range(len(A)):
                if A[i][j]==0:
                    A[i][j]=1
                elif A[i][j]!=0:
                    A[i][j]=0
        return A


def NEvec(A):
    for i in range(len(A)):
        if A[i]==0:
            A[i]=1
        elif A[i]!=0:
            A[i]=0
    return A

    
def Ho(A):
    X=np.zeros([len(A),1])
    for i in range(np.size(A,1)):
        X[i][0]=np.sum(A[i])
    return X
    
def cwprod(A,B):
    return A*B

def lis_cwprod(lis):
    return ft.reduce(cwprod,lis)

def D(A):
    for i in range(0,len(A)):
        A[i][i]=0
    return A

def exp(A,n):
    lis=[np.identity(len(A)),A]
    if n==0:
        return np.identity(len(A))
    elif n==1:
        return A
    elif n>1:
        for k in range(1,n):
            lis[k]=np.dot(A,lis[k])
            lis.append(lis[k])
        return lis[n]


def trans_ex(A,m):
    lis=[A,NO(D(D(A)+np.dot(D(A),D(A))))]
    if m==0:
        return lis[0]
    elif m==1:
        return lis[1]
    elif m>1:
        for i in range(1,m):
            X=D(trans_ex(A,i))
            lis.append(NO(D(X+np.dot(X,X))))
        return lis[m]

def testex(x,n):
    lis=[1,x]
    if n==0:
        return lis[0]
    elif n==1:
        return lis[1]
    elif n>1:
        for i in range(1,n):
            X=x*testex(x,i)
            lis.append(X)
        return lis[n]


def find_min(y=s):
    lis0=[]
    for x in range(0,y+1):
        if y-2<2**x:
            lis0.append(x)
    return lis0[0]


def closure(A):
    return trans_ex(A,find_min(s))

def transitive_closure(a):
    if isinstance(a,np.ndarray):
        res=np.zeros([len(a),len(a)])
        l=len(a)
        for i in range(l):
            for j in range(l):
                for k in range(l):
                    if a[i][j]!=0 and a[j][k]!=0:
                        pass
    elif isinstance(a,list) or isinstance(a,tuple):
        pass

def rble(player,S=DM,G=graphs):
    x=S.index(player)
    X=G[x]
    return X


def rble_lis(i,s,S=State,G=graphs):
    lis=[]
    for t in S:
        if G[i-1][s-1][t-1]==1:
            lis.append(t)
    return lis



def pref(player,S=DM,P=prefs):
    x=S.index(player)
    X=pref_mat(P[x])
    for i in range(len(X)):
        X[i][i]=0
    return X


def strblei(player):
    return D(rble(player))


def srblei_lis(i,s,S=State,G=[rble(player) for player in DM]):
    lis=[]
    for t in S:
        if G[i-1][s-1][t-1]==1:
            lis.append(t)
    return lis


def stimpi(player):
    return strblei(player)*pref(player)



def jpref(H):
    if len(H)==0:
        return np.ones([len(State),len(State)])
    else:
        return ft.reduce(cwprod,[pref(i) for i in H])

def strblec(H):
    if H==[]:
        return np.zeros([s,s])
    else:
        return closure(lis_sum([strblei(i) for i in H]))

def stimpc(H):
    return closure(lis_sum([stimpi(i) for i in H]))

def costimp(H):
    return strblec(H)*jpref(H)

def clstrble(C):
    if C==[]:
        return np.zeros([s,s])
    else:
        return closure(lis_sum([strblec(H) for H in C]))



def clstimp(C):
    if C==[]:
        return np.zeros([s,s])
    else:
        return closure(lis_sum([costimp(H) for H in C]))

def lessor(player):
    if isinstance(player, list):
        return NE(jpref(player))
    else:
        return NE(pref(player))



def mat2lis(i,A,S):
    lis=[]
    for j in S:
        if A[i-1][j-1]==1:
            lis.append(j)
    return lis


