import sympy as sy
from input_time import *
from setop import *
from matrixop import *
from timeop import *

def Nash_state(player):
    lis=[]
    for i in range(s):
        if NE(Ho(stimpi(player)))[i]==1:
            lis.append(i+1)
    return lis


def GMR_state(player):
    lis=[]
    for i in range(s):
        if NE(stimpi(player).dot(NE(strblec(setminus(player)).dot(T(lessor(player))))))[i][i]==1:
            lis.append(i+1)
    return lis

def SMR_state(player):
    lis=[]
    for i in range(s):
        if NE(stimpi(player).dot(NE(strblec(setminus(player,DM)).dot(T(cwprod(lessor(player),T(NE(strblei(player).dot(T(NE(lessor(player))))))))))))[i][i]==1:
            lis.append(i+1)
    return lis

def SEQ_state(player):
    lis=[]
    for i in range(s):
        if NE(stimpi(player).dot(NE(stimpc(setminus(player)).dot(T(lessor(player))))))[i][i]==1:
            lis.append(i+1)
    return lis


def Nash_eq():
    lis0=[]
    for player in DM:
        lis0.append(Nash_state(player))
    return sorted(intersect(lis0))


def GMR_eq():
    lis0=[]
    for player in DM:
        lis0.append(GMR_state(player))
    return sorted(intersect(lis0))

def SEQ_eq():
    lis0=[]
    for player in DM:
        lis0.append(SEQ_state(player))
    return sorted(intersect(lis0))


def SMR_eq():
    lis0=[]
    for player in DM:
        lis0.append(SMR_state(player))
    return sorted(intersect(lis0))


def CNash_state(H):
    lis=[]
    if isinstance(H, list):
        for i in range(s):
            if NE(Ho(costimp(H)))[i]==1:
                lis.append(i+1)
        return lis
    else :        
        x=lis_cwprod([NE(Ho(costimp(i))) for i in coalinclu(H)])
        return [k+1 for k in range(0,len(x))  if x[k]==1]


def CGMR_state(H):
    lis=[]
    if isinstance(H, list):
        for i in range(0,s):
            if NE(np.dot(costimp(H),NE(np.dot(clstrble(clsminus(H)),T(lessor(H))))))[i][i]==1:
                lis.append(i+1)
        return lis
    else :        
        x=lis_cwprod([NE(np.dot(costimp(i),NE(np.dot(clstrble(clsminus(i)),T(lessor(i)))))) for i in coalinclu(H)])
        return [k+1 for k in range(0,len(x))  if x[k][k]==1]


def CSMR_state(H):
    lis=[]
    if isinstance(H, list):
        for i in range(s):
            if NE(costimp(H).dot(NE(clstrble(clsminus(H)).dot(T(cwprod(lessor(H),T(NE(strblec(H).dot(T(NE(lessor(H))))))))))))[i][i]==1:
                lis.append(i+1)
        return lis
    else :        
        x=lis_cwprod([NE(costimp(i).dot(NE(clstrble(clsminus(i)).dot(T(cwprod(lessor(i),T(NE(strblec(i).dot(T(NE(lessor(i)))))))))))) for i in coalinclu(H)])
        return [k+1 for k in range(0,len(x))  if x[k][k]==1]



def CSEQ_state(H):
    lis=[]
    if isinstance(H, list):
        for i in range(s):
            if NE(np.dot(costimp(H),NE(np.dot(clstimp(clsminus(H)),T(lessor(H))))))[i][i]==1:
                lis.append(i+1)
        return lis
    else :        
         x=lis_cwprod([NE(np.dot(costimp(i),NE(np.dot(clstimp(clsminus(i)),T(lessor(i)))))) for i in coalinclu(H)])
         return [k+1 for k in range(0,len(x))  if x[k][k]==1]




def CNash_eq():
    lis0=[]
    for player in DM:
        lis0.append(CNash_state(player))
    return sorted(intersect(lis0))


def CGMR_eq():
    lis0=[]
    for player in DM:
        lis0.append(CGMR_state(player))
    return sorted(intersect(lis0))

def CSEQ_eq():
    lis0=[]
    for player in DM:
        lis0.append(CSEQ_state(player))
    return sorted(intersect(lis0))


def CSMR_eq():
    lis0=[]
    for player in DM:
        lis0.append(CSMR_state(player))
    return sorted(intersect(lis0))   

def tNash_state(player):
    lis=[]
    for i in range(s):
        if NE(Ho(tRimp(player,setminus(player,DM))))[i]==1:
            lis.append(i+1)
    return lis

def tNashc_state(player):
    lis=[]
    for i in range(s):
        if NE(Ho(tcRimp(player,setminus(player,DM))))[i]==1:
            lis.append(i+1)
    return lis

def tGMR_state(player):
    lis=[]
    for i in range(s):
        if NE(tRimp(player,setminus(player,DM)).dot(NE(tRc(setminus(player,DM),player).dot(T(lessor(player))))))[i][i]==1:
            lis.append(i+1)
    return lis

def tcGMR_state(player):
    lis=[]
    for i in range(s):
        if NE(tRimp(player,setminus(player,DM)).dot(NE(tcRc(setminus(player,DM),player).dot(T(lessor(player))))))[i][i]==1:
            lis.append(i+1)
    return lis

def tGMRc_state(player):
    lis=[]
    for i in range(s):
        if NE(tcRimp(player,setminus(player,DM)).dot(NE(tRc(setminus(player,DM),player).dot(T(lessor(player))))))[i][i]==1:
            lis.append(i+1)
    return lis

def tcGMRc_state(player):
    lis=[]
    for i in range(s):
        if NE(tcRimp(player,setminus(player,DM)).dot(NE(tcRc(setminus(player,DM),player).dot(T(lessor(player))))))[i][i]==1:
            lis.append(i+1)
    return lis

def tSMR_state(player):
    lis=[]
    for i in range(s):
        if NE(tRimp(player,setminus(player,DM)).dot(NE(tRc(setminus(player,DM),player).dot(T(lessor(player)*(T(NE(tR(player,setminus(player,DM)).dot(T(NE(lessor(player))))))))))))[i][i]==1:
            lis.append(i+1)
    return lis

def tcSMR_state(player):
    lis=[]
    for i in range(s):
        if NE(tRimp(player,setminus(player,DM)).dot(NE(tcRc(setminus(player,DM),player).dot(T(lessor(player)*(T(NE(tR(player,setminus(player,DM)).dot(T(NE(lessor(player))))))))))))[i][i]==1:
            lis.append(i+1)
    return lis

def tSMRc_state(player):
    lis=[]
    for i in range(s):
        if NE(tcRimp(player,setminus(player,DM)).dot(NE(tRc(setminus(player,DM),player).dot(T(lessor(player)*(T(NE(tcR(player,setminus(player,DM)).dot(T(NE(lessor(player))))))))))))[i][i]==1:
            lis.append(i+1)
    return lis

def tcSMRc_state(player):
    lis=[]
    for i in range(s):
        if NE(tcRimp(player,setminus(player,DM)).dot(NE(tcRc(setminus(player,DM),player).dot(T(lessor(player)*(T(NE(tcR(player,setminus(player,DM)).dot(T(NE(lessor(player))))))))))))[i][i]==1:
            lis.append(i+1)
    return lis

def tSEQ_state(player):
    lis=[]
    for i in range(s):
        if NE(tRimp(player,setminus(player,DM)).dot(NE(tRimpc(setminus(player,DM),player).dot(T(lessor(player))))))[i][i]==1:
            lis.append(i+1)
    return lis

def tcSEQ_state(player):
    lis=[]
    for i in range(s):
        if NE(tRimp(player,setminus(player,DM)).dot(NE(tcRimpc(setminus(player,DM),player).dot(T(lessor(player))))))[i][i]==1:
            lis.append(i+1)
    return lis

def tSEQc_state(player):
    lis=[]
    for i in range(s):
        if NE(tcRimp(player,setminus(player,DM)).dot(NE(tRimpc(setminus(player,DM),player).dot(T(lessor(player))))))[i][i]==1:
            lis.append(i+1)
    return lis

def tcSEQc_state(player):
    lis=[]
    for i in range(s):
        if NE(tcRimp(player,setminus(player,DM)).dot(NE(tcRimpc(setminus(player,DM),player).dot(T(lessor(player))))))[i][i]==1:
            lis.append(i+1)
    return lis



########################################################Equilibria########################################################

def tNash_eq():
    lis0=[]
    for player in DM:
        lis0.append(tNash_state(player))
    return sorted(intersect(lis0))

def tNashc_eq():
    lis0=[]
    for player in DM:
        lis0.append(tNashc_state(player))
    return sorted(intersect(lis0))


def tGMR_eq():
    lis0=[]
    for player in DM:
        lis0.append(tGMR_state(player))
    return sorted(intersect(lis0))

def tcGMR_eq():
    lis0=[]
    for player in DM:
        lis0.append(tcGMR_state(player))
    return sorted(intersect(lis0))

def tGMRc_eq():
    lis0=[]
    for player in DM:
        lis0.append(tGMRc_state(player))
    return sorted(intersect(lis0))

def tcGMRc_eq():
    lis0=[]
    for player in DM:
        lis0.append(tcGMRc_state(player))
    return sorted(intersect(lis0))

def tSEQ_eq():
    lis0=[]
    for player in DM:
        lis0.append(tSEQ_state(player))
    return sorted(intersect(lis0))

def tcSEQ_eq():
    lis0=[]
    for player in DM:
        lis0.append(tcSEQ_state(player))
    return sorted(intersect(lis0))

def tSEQc_eq():
    lis0=[]
    for player in DM:
        lis0.append(tSEQc_state(player))
    return sorted(intersect(lis0))

def tcSEQc_eq():
    lis0=[]
    for player in DM:
        lis0.append(tcSEQc_state(player))
    return sorted(intersect(lis0))


def tSMR_eq():
    lis0=[]
    for player in DM:
        lis0.append(tSMR_state(player))
    return sorted(intersect(lis0))

def tcSMR_eq():
    lis0=[]
    for player in DM:
        lis0.append(tcSMR_state(player))
    return sorted(intersect(lis0))

def tSMRc_eq():
    lis0=[]
    for player in DM:
        lis0.append(tSMRc_state(player))
    return sorted(intersect(lis0))

def tcSMRc_eq():
    lis0=[]
    for player in DM:
        lis0.append(tcSMRc_state(player))
    return sorted(intersect(lis0))


######################### Coalitional Stabilities #########################

def tCNash_state(H):
    lis=[]
    if isinstance(H, list):
        for i in range(s):
            if NE(Ho(stRimpc(H,minusset(H,DM))))[i]==1:
                lis.append(i+1)
        return lis
    else :        
        x=lis_cwprod([NE(Ho(stRimpc(i,minusset(i,DM)))) for i in coalinclu(H)])
        return [k+1 for k in range(0,len(x))  if x[k]==1]

def tCNashc_state(H):
    lis=[]
    if isinstance(H, list):
        for i in range(s):
            if NE(Ho(stcRimpc(H,minusset(H,DM))))[i]==1:
                lis.append(i+1)
        return lis
    else :        
        x=lis_cwprod([NE(Ho(stcRimpc(i,minusset(i,DM)))) for i in coalinclu(H)])
        return [k+1 for k in range(0,len(x))  if x[k]==1]

def tCGMR_state(H):
    lis=[]
    if isinstance(H, list):
        for i in range(0,s):
            if NE(np.dot(stRimpc(H,minusset(H,DM)),NE(np.dot(tRcls(psetminus(H,DM),H),T(lessor(H))))))[i][i]==1:
                lis.append(i+1)
        return lis
    else :
        x=lis_cwprod([NE(np.dot(stRimpc(i,minusset(i,DM)),NE(np.dot(tRcls(psetminus(i,DM),i),T(lessor(i)))))) for i in coalinclu(H)])
        return [k+1 for k in range(0,len(x))  if x[k][k]==1]



def tCGMRc_state(H):
    lis=[]
    if isinstance(H, list):
        for i in range(0,s):
            if NE(np.dot(stcRimpc(H,minusset(H,DM)),NE(np.dot(tRcls(psetminus(H,DM),H),T(lessor(H))))))[i][i]==1:
                    lis.append(i+1)
        return lis
    else :        
        x=lis_cwprod([NE(np.dot(stcRimpc(i,minusset(i,DM)),NE(np.dot(tRcls(psetminus(i,DM),i),T(lessor(i)))))) for i in coalinclu(H)])
        return [k+1 for k in range(0,len(x))  if x[k][k]==1]

def tcCGMR_state(H):
    lis=[]
    if isinstance(H, list):
        for i in range(0,s):
            if NE(np.dot(stRimpc(H,minusset(H,DM)),NE(np.dot(tcRcls(psetminus(H,DM),H),T(lessor(H))))))[i][i]==1:
                    lis.append(i+1)
        return lis
    else :        
        x=lis_cwprod([NE(np.dot(stRimpc(i,minusset(i,DM)),NE(np.dot(tcRcls(psetminus(i,DM),i),T(lessor(i)))))) for i in coalinclu(H)])
        return [k+1 for k in range(0,len(x))  if x[k][k]==1]

def tcCGMRc_state(H):
    lis=[]
    if isinstance(H, list):
        for i in range(0,s):
            if NE(np.dot(stcRimpc(H,minusset(H,DM)),NE(np.dot(tcRcls(psetminus(H,DM),H),T(lessor(H))))))[i][i]==1:
                    lis.append(i+1)
        return lis
    else :        
        x=lis_cwprod([NE(np.dot(stcRimpc(i,minusset(i,DM)),NE(np.dot(tcRcls(psetminus(i,DM),i),T(lessor(i)))))) for i in coalinclu(H)])
        return [k+1 for k in range(0,len(x))  if x[k][k]==1]

def tCSMR_state(H):
    lis=[]
    if isinstance(H, list):
        for i in range(s):
            if NE(stRimpc(H,minusset(H,DM)).dot(NE(tRcls(psetminus(H,DM),H).dot(T(cwprod(lessor(H),T(NE(tRc(H,minusset(H,DM)).dot(T(NE(lessor(H))))))))))))[i][i]==1:
                lis.append(i+1)
        return lis
    else :        
        x=lis_cwprod([NE(stRimpc(i,minusset(i,DM)).dot(NE(tRcls(psetminus(i,DM),i).dot(T(cwprod(lessor(i),T(NE(tRc(i,minusset(i,DM)).dot(T(NE(lessor(i)))))))))))) for i in coalinclu(H)])
        return [k+1 for k in range(0,len(x))  if x[k][k]==1]

def tCSMRc_state(H):
    lis=[]
    if isinstance(H, list):
        for i in range(s):
            if NE(stRimpc(H,minusset(H,DM)).dot(NE(tRcls(psetminus(H,DM),H).dot(T(cwprod(lessor(H),T(NE(tcRc(H,minusset(H,DM)).dot(T(NE(lessor(H))))))))))))[i][i]==1:
                lis.append(i+1)
        return lis
    else :        
        x=lis_cwprod([NE(stRimpc(i,minusset(i,DM)).dot(NE(tRcls(psetminus(i,DM),i).dot(T(cwprod(lessor(i),T(NE(tcRc(i,minusset(i,DM)).dot(T(NE(lessor(i)))))))))))) for i in coalinclu(H)])
        return [k+1 for k in range(0,len(x))  if x[k][k]==1]


def tcCSMR_state(H):
    lis=[]
    if isinstance(H, list):
        for i in range(s):
            if NE(stRimpc(H,minusset(H,DM)).dot(NE(tcRcls(psetminus(H,DM),H).dot(T(cwprod(lessor(H),T(NE(tRc(H,minusset(H,DM)).dot(T(NE(lessor(H))))))))))))[i][i]==1:
                lis.append(i+1)
        return lis
    else :        
        x=lis_cwprod([NE(stRimpc(i,minusset(i,DM)).dot(NE(tcRcls(psetminus(i,DM),i).dot(T(cwprod(lessor(i),T(NE(tRc(i,minusset(i,DM)).dot(T(NE(lessor(i)))))))))))) for i in coalinclu(H)])
        return [k+1 for k in range(0,len(x))  if x[k][k]==1]

def tcCSMRc_state(H):
    lis=[]
    if isinstance(H, list):
        for i in range(s):
            if NE(stRimpc(H,minusset(H,DM)).dot(NE(tcRcls(psetminus(H,DM),H).dot(T(cwprod(lessor(H),T(NE(tcRc(H,minusset(H,DM)).dot(T(NE(lessor(H))))))))))))[i][i]==1:
                lis.append(i+1)
        return lis
    else :        
        x=lis_cwprod([NE(stRimpc(i,minusset(i,DM)).dot(NE(tcRcls(psetminus(i,DM),i).dot(T(cwprod(lessor(i),T(NE(tcRc(i,minusset(i,DM)).dot(T(NE(lessor(i)))))))))))) for i in coalinclu(H)])
        return [k+1 for k in range(0,len(x))  if x[k][k]==1]


def tCSEQ_state(H):
    lis=[]
    if isinstance(H, list):
        for i in range(s):
            if NE(np.dot(stRimpc(H,minusset(H,DM)),NE(np.dot(tRimpcls(psetminus(H,DM),H),T(lessor(H))))))[i][i]==1:
                lis.append(i+1)
        return lis
    else :        
        x=lis_cwprod([NE(np.dot(stRimpc(i,minusset(i,DM)),NE(np.dot(tRimpcls(psetminus(i,DM),i),T(lessor(i)))))) for i in coalinclu(H)])
        return [k+1 for k in range(0,len(x))  if x[k][k]==1]

def tCSEQc_state(H):
    lis=[]
    if isinstance(H, list):
        for i in range(s):
            if NE(np.dot(stcRimpc(H,minusset(H,DM)),NE(np.dot(tRimpcls(psetminus(H,DM),H),T(lessor(H))))))[i][i]==1:
                lis.append(i+1)
        return lis
    else :        
        x=lis_cwprod([NE(np.dot(stcRimpc(i,minusset(i,DM)),NE(np.dot(tRimpcls(psetminus(i,DM),i),T(lessor(i)))))) for i in coalinclu(H)])
        return [k+1 for k in range(0,len(x))  if x[k][k]==1]

def tcCSEQ_state(H):
    lis=[]
    if isinstance(H, list):
        for i in range(s):
            if NE(np.dot(stRimpc(H,minusset(H,DM)),NE(np.dot(tcRimpcls(psetminus(H,DM),H),T(lessor(H))))))[i][i]==1:
                lis.append(i+1)
        return lis
    else :        
        x=lis_cwprod([NE(np.dot(stRimpc(i,minusset(i,DM)),NE(np.dot(tcRimpcls(psetminus(i,DM),i),T(lessor(i)))))) for i in coalinclu(H)])
        return [k+1 for k in range(0,len(x))  if x[k][k]==1]

def tcCSEQc_state(H):
    lis=[]
    if isinstance(H, list):
        for i in range(s):
            if NE(np.dot(stcRimpc(H,minusset(H,DM)),NE(np.dot(tcRimpcls(psetminus(H,DM),H),T(lessor(H))))))[i][i]==1:
                lis.append(i+1)
        return lis
    else :        
        x=lis_cwprod([NE(np.dot(stcRimpc(i,minusset(i,DM)),NE(np.dot(tcRimpcls(psetminus(i,DM),i),T(lessor(i)))))) for i in coalinclu(H)])
        return [k+1 for k in range(0,len(x))  if x[k][k]==1]


########################################################Equilibria########################################################

def tCNash_eq():
    lis0=[]
    for player in DM:
        lis0.append(tCNash_state(player))
    return sorted(intersect(lis0))

def tCNashc_eq():
    lis0=[]
    for player in DM:
        lis0.append(tCNashc_state(player))
    return sorted(intersect(lis0))

def tCGMR_eq():
    lis0=[]
    for player in DM:
        lis0.append(tCGMR_state(player))
    return sorted(intersect(lis0))

def tCGMRc_eq():
    lis0=[]
    for player in DM:
        lis0.append(tCGMRc_state(player))
    return sorted(intersect(lis0))

def tcCGMR_eq():
    lis0=[]
    for player in DM:
        lis0.append(tcCGMR_state(player))
    return sorted(intersect(lis0))

def tcCGMRc_eq():
    lis0=[]
    for player in DM:
        lis0.append(tcCGMRc_state(player))
    return sorted(intersect(lis0))

def tCSMR_eq():
    lis0=[]
    for player in DM:
        lis0.append(tCSMR_state(player))
    return sorted(intersect(lis0)) 
	
def tCSMRc_eq():
    lis0=[]
    for player in DM:
        lis0.append(tCSMRc_state(player))
    return sorted(intersect(lis0)) 
	
def tcCSMR_eq():
    lis0=[]
    for player in DM:
        lis0.append(tcCSMR_state(player))
    return sorted(intersect(lis0)) 
	
def tcCSMRc_eq():
    lis0=[]
    for player in DM:
        lis0.append(tcCSMRc_state(player))
    return sorted(intersect(lis0)) 
	
def tCSEQ_eq():
    lis0=[]
    for player in DM:
        lis0.append(tCSEQ_state(player))
    return sorted(intersect(lis0))

def tCSEQc_eq():
    lis0=[]
    for player in DM:
        lis0.append(tCSEQc_state(player))
    return sorted(intersect(lis0))

def tcCSEQ_eq():
    lis0=[]
    for player in DM:
        lis0.append(tcCSEQ_state(player))
    return sorted(intersect(lis0))

def tcCSEQc_eq():
    lis0=[]
    for player in DM:
        lis0.append(tcCSEQc_state(player))
    return sorted(intersect(lis0))
