import sympy as sy
from setop import *
from matrixop import *
from input_time import *


x=sy.Symbol("x",positive=True)

def indexofelement(info,lis):
    for k in range(len(lis)):
        if np.all(info==lis[k]):
            return k

def typeofelement(lis,Type):
    res=[]
    for item in lis:
        if isinstance(item,Type):
            res.append(True)
        else:
            res.append(False)
    return all(res)


def findmax():
    Res=[]
    for X in times:
        for i in range(len(X)):
            for j in range(len(X)):
                if sy.Matrix(X)[i,j]!=x:
                    Res.append(sy.Matrix(X)[i,j])
    return max(Res)


def findmax0():
    Res=[]
    for player in DM:
        k=DM.index(player)
        X=graphs[k]
        for i in range(len(X)):
            for j in range(len(X)):
                if sy.Matrix(X)[i,j]==1:
                    Res.append(sy.Matrix(times[k])[i,j])
    return max(Res)


def time2rble(info):
    if isinstance(info,int):
        ind=DM.index(info)
        X=times[ind]
        k=len(X)
        Res=np.zeros([k,k])
        for i in range(k):
            for j in range(k):
                if i==j:
                    Res[i][j]=0
                elif i!=j and X[i][j]==x:
                    Res[i][j]=0
                elif i!=j and X[i][j]!=x:
                    Res[i][j]=1
        return Res
    elif isinstance(info,np.ndarray):
        l=len(info)
        Res=np.zeros([l,l])
        for i in range(l):
            for j in range(l):
                if i==j:
                    Res[i][j]=0
                elif i!=j and info[i][j]==x:
                    Res[i][j]=0
                elif i!=j and info[i][j]!=x:
                    Res[i][j]=1
        return Res
    else:
        pass


      
def weaktime(info):
    if isinstance(info,int):
        k=DM.index(info)
        X=times[k]
        Res=np.zeros([len(X),len(X)])
        for i in range(len(X)):
            for j in range(len(X)):
                if X[i][j]==x:
                    Res[i][j]=0
                elif X[i][j]!=x:
                    Res[i][j]=X[i][j]
        return Res
    elif isinstance(info,np.ndarray):
        l=len(info)
        Res=np.zeros([l,l])
        for i in range(l):
            for j in range(l):
                if info[i][j]==x:
                    Res[i][j]=0
                elif info[i][j]!=x:
                    Res[i][j]=info[i][j]
        return Res

def strtime(info):
    if isinstance(info,np.ndarray):
        X=sy.Matrix(info)
        return np.array(X.subs(x,findmax()+1))
    elif isinstance(info,int):
        ind=DM.index(info)
        X=sy.Matrix(times[ind])
        return np.array(X.subs(x,findmax()+1))
        
def timeimpi(info):
    if isinstance(info,int):
        return weaktime(info)+(1+findmax())*NE(cwprod(time2rble(info),pref_mat(prefs[indexofelement(info,DM)])))
    elif isinstance(info,np.ndarray):
        return weaktime(info)+(1+findmax())*NE(cwprod(time2rble(info),pref_mat(prefs[indexofelement(info,times)])))

def minmat(matrix):
    if isinstance(matrix,np.ndarray):
        X=np.array((sy.Matrix(matrix)).subs(x,findmax()+1))
        l=len(matrix)
        Res=np.zeros([l,l])
        for i in range(l):
            Min=min(X[i])
            for j in range(l):
                Res[i][j]=Min
        return Res

def adj(info):
    if isinstance(info,np.ndarray):
        l=len(info)
        Res=np.zeros([l,l])
        for i in range(l):
            for j in range(l):
                if info[i][j]>0 or info[i][j]==0:
                    Res[i][j]=1
                elif info[i][j]<0:
                    Res[i][j]=0
        return Res

######################################################## time reachable and improvements ########################################################

def tR(info,against):
    if (isinstance(against,list) and len(against)==1) or isinstance(against,int):
        if isinstance(against,list):
            return cwprod(time2rble(info),adj(minmat(strtime(against[0]))-strtime(info)))
        elif isinstance(against,int):
            return cwprod(time2rble(info),adj(minmat(strtime(against))-strtime(info)))
    elif isinstance(against,list) and len(against)>1:
        Res=[]
        for member in against:
            Res.append(cwprod(time2rble(info),adj(minmat(strtime(member))-strtime(info))))
        return lis_cwprod(Res)
    elif against==[]:
        return D(rble(info))

def tcR(info,against):
    if (isinstance(against,list) and len(against)==1) or isinstance(against,int):
        if isinstance(against,list):
            return cwprod(time2rble(info),adj(minmat(timeimpi(against[0]))-strtime(info))) 
        elif isinstance(against,int):
            return cwprod(time2rble(info),adj(minmat(timeimpi(against))-strtime(info))) 
    elif isinstance(against,list) and len(against)>1:
        Res=[]
        for member in against:
            Res.append(cwprod(time2rble(info),adj(minmat(timeimpi(member))-strtime(info))) )
        return lis_cwprod(Res)
    elif against==[]:
        return D(rble(info))


def tRimp(info,against):
    return cwprod(tR(info,against),stimpi(info))

def tcRimp(info,against):
    return cwprod(tcR(info,against),stimpi(info))

########################################################Coalitional Definition########################################################

def tRc(player,against):#tR_{H,T}
    if player==[]:
        return np.zeros([s,s])
    else:
        return closure(lis_sum([tR(info,against) for info in player]))

def tcRc(player,against):#tcR_{H,T}
    if player==[]:
        return np.zeros([s,s])
    else:
        return closure(lis_sum([tcR(info,against) for info in player]))

def tRimpc(player,against):#tR_{H,T}^+
    if player==[]:
        return np.zeros([s,s])
    else:
        return closure(lis_sum([tRimp(info,against) for info in player]))

def tcRimpc(player,against):#tcR_{H,T}^+
    if player==[]:
        return np.zeros([s,s])
    else:
        return closure(lis_sum([tcRimp(info,against) for info in player]))

def stRimpc(player,against):#tR_{H,T}^{++}
    return cwprod(tRc(player,against),jpref(player))

def stcRimpc(player,against):#tcR_{H,T}^{++}
    return cwprod(tcRc(player,against),jpref(player))


def tRcls(player,against):#tR_{{\cal C},T}
    if player==[]:
        return np.zeros([s,s])
    else:
        return closure(lis_sum([tRc(info,against) for info in player]))

def tcRcls(player,against):#tcR_{{\cal C},T}
    if player==[]:
        return np.zeros([s,s])
    else:
        return closure(lis_sum([tcRc(info,against) for info in player]))

def tRimpcls(player,against):#tR_{{\cal C},T}^{++}
    if player==[]:
        return np.zeros([s,s])
    else:
        return closure(lis_sum([stRimpc(info,against) for info in player]))

def tcRimpcls(player,against):#tcR_{{\cal C},T}^{++}
    if player==[]:
        return np.zeros([s,s])
    else:
        return closure(lis_sum([stcRimpc(info,against) for info in player]))
